<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: all_tests.php 2409 2005-04-07 14:28:24Z andrew $
*/

/**
 * @package    Max
 * @subpackage TestSuite
 * @author     Radek Maciaszek <radek@awarez.net>
 */

/**
 * A class for running the Delivery Engine tests. Designed to be included
 * in a main, project-wide all_tests.php file, or to be run by itself.
 */
class MAX_Plugins_Tests
{
    
    function run()
    {
        // Setup the testing environment
        if (!defined('MAX_PATH')) {
            include_once '../../../../constants.php';
        }
        include_once MAX_PATH . '/tests/testEnvironment.php';
        $testEnvironment = new testEnvironment();
        $testEnvironment->init();
        $oldLevel = error_reporting(E_ALL);
        $test = &new GroupTest('Plugins: Base Tests');
        $test->addTestFile(MAX_PATH . '/lib/max/Plugins/tests/FileScanner.test.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Plugins/tests/Plugins.test.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Plugins/tests/PluginTranslation.test.php');
        $test->run(new HtmlReporter());
        error_reporting($oldLevel);
        // Close off the testing environment
        $testEnvironment->deinit();
    }
    
}

MAX_Plugins_Tests::run();

?>