<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-invocation.inc.php 2464 2005-04-08 16:57:48Z radek $
*/

// Required files
require_once MAX_PATH . '/lib/max/Delivery.php';
require_once MAX_PATH . '/lib/max/language/Invocation.php';
require_once MAX_PATH . '/lib/max/other/db_proc.php';
require_once MAX_PATH . '/lib/max/Admin_DA.php';

require_once MAX_PATH . '/lib/max/Plugins/Plugins.php';
require_once MAX_PATH . '/lib/max/Plugins/PluginTranslation.php';

// include default invocation
//require_once MAX_PATH . '/plugins/invocationTags/adlayer/layerstyles/floater/invocation.inc.php';

// Register input variables
phpAds_registerGlobal (
     'block'
    ,'bannerid'
    ,'blockcampaign'
    ,'campaignid'
    ,'clientid'
    ,'codetype'
    ,'delay'
    ,'delay_type'
    ,'generate'
    ,'height'
    ,'hostlanguage'
    ,'ilayer'
    ,'layerstyle'
    ,'left'
    ,'location'
    ,'menubar'
    ,'popunder'
    ,'raw'
    ,'refresh'
    ,'resizable'
    ,'resize'
    ,'scrollbars'
    ,'source'
    ,'status'
    ,'submitbutton'
    ,'target'
    ,'template'
    ,'thirdpartytrack'
    ,'timeout'
    ,'toolbars'
    ,'top'
    ,'transparent'
    ,'uniqueid'
    ,'website'
    ,'what'
    ,'width'
    ,'withtext'
    ,'xmlrpcproto'
    ,'xmlrpctimeout'
);

// Load the required language files
Language_Invocation::load();

/**
 * Max_Invocation class is a common class for placingInvocationForm(s)
 * and generating invocation codes
 *
 */
class Max_Invocation {

    /**
     * Generate bannercode (invocation code for banner)
     *
     * @param object $invocationTag    If null the invocation tag is factory by Max_Plugins class,
     *                                 else this object is used
     *
     * @return string    Generated invocation code
     */
    function generateInvocationCode(&$invocationTag)
    {
        
        $conf = $GLOBALS['_MAX']['CONF'];
    
        $globalVariables = array(
            'affiliateid', 'bannerid', 'block',
            'blockcampaign', 'campaignid', 'clientid',
            'codetype', 'delay', 'delay_type',
            'domains_table', 'extra', 'height',
            'hostlanguage', 'ilayer', 'left',
            'location', 'menubar', 'parameters', 'popunder',
            'raw', 'refresh', 'resizable',
            'resize', 'scrollbars', 'source',
            'status', 'target', 'template',
            'thirdpartytrack', 'timeout', 'toolbars',
            'top', 'transparent', 'uniqueid',
            'website', 'what', 'width',
            'withtext', 'zoneid', 'xmlrpcproto',
            'xmlrpctimeout'
        );
        
        foreach($globalVariables as $makeMeGlobal) {
            global $$makeMeGlobal;
            // also make this variable a class attribute
            // so plugins could have an access to these values (and modify them)
            $this->$makeMeGlobal = &$$makeMeGlobal;
        }
        
        if($invocationTag === null) {
            $invocationTag = Max_Plugins::factory('invocationTag', $codetype);
        }
        if($invocationTag === false) {
            MAX::debug('Error while factory invocationTag plugin');
            exit();
        }

        // pass global variables as object attributes
        $invocationTag->setInvocation($this);
        
        // generate invocation code
        return $invocationTag->generateInvocationCode();
    }

    /**
     * Generate tracker code
     *
     * @return string  Generated tracker code
     */
    function generateTrackerCode($trackerId)
    {
        $conf = $GLOBALS['_MAX']['CONF'];
        global $trackerid;
        
        $variablesComment = '';
        $variablesQuerystring = '';
        
        $variables = Admin_DA::getVariables(array('tracker_id' => $trackerId), true);
        
        foreach ($variables as $variable) {
            $variablesComment .= "  -- Each time the page with this code on it is loaded, replace the\n";
            $variablesComment .= "  -- text INSERT_{$variable['name']}_VALUE below with the value for the\n";
            $variablesComment .= "  -- \"{$variable['description']}\" variable value, named \"{$variable['name']}\".\n";
            $variablesQuerystring .= "&{$variable['name']}=INSERT_{$variable['name']}_VALUE";
        }
        $buffer = '<!-- Max Media Manager Tracker Image Beacon Code' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- Generated with Max ' . MAX_VERSION_READABLE . "\n";
        if (isset($variablesComment) && ($variablesComment != '')) {
            $buffer .= '  --' . "\n";
            $buffer .= "$variablesComment";
        }
        $buffer .= "  --
  -- Replace INSERT_RANDOM with a random number or timestamp that is
  -- generated each time the page with this code on it is loaded, to
  -- ensure that the logging of the tracker beacon is not cached.
  --
  -- If this beacon is going on an SSL page, replace
  --  'http://{$conf['webpath']['delivery']}/...'
  -- with
  --  'https://{$conf['webpath']['deliverySSL']}/...'
  --
  -- Put this tag in the <head> portion of the web page you want to track.
  -- Any variables that will be tracked along with the beacon were
  -- configured at the time this beacon code was generated, so if you want
  -- to change the variables tracked, this code will need to be
  -- re-generated in Max Media Manager.
  -->

<img src='".constructDeliveryURL($conf['file']['conversion'])."?trackerid={$trackerId}{$variablesQuerystring}&cb=INSERT_RANDOM' width='1' height='1' border='0' />";
        return $buffer;
    }

    /**
     * Place invocation form - generate form with group of options for every plugin,
     * look into max/docs/developer/plugins.zuml for more details
     *
     * @param array $extra
     * @param boolean $zone_invocation
     *
     * @return string  Generated invocation form
     */
    function placeInvocationForm($extra = '', $zone_invocation = false)
    {
        $conf = $GLOBALS['_MAX']['CONF'];
        $pref = $GLOBALS['_MAX']['PREF'];
        
        $globalVariables = array(
            'block', 'blockcampaign', 'campaignid',
            'clientid', 'codetype', 'delay',
            'delay_type', 'generate', 'height',
            'hostlanguage', 'ilayer', 'layerstyle',
            'left', 'location', 'menubar',
            'phpAds_TextDirection', 'popunder', 'raw',
            'refresh', 'resizable', 'resize',
            'scrollbars', 'source', 'status',
            'submitbutton', 'tabindex', 'target',
            'template', 'timeout', 'toolbars',
            'top', 'transparent', 'uniqueid',
            'what', 'width', 'withtext',
            'bannerid', 'thirdpartytrack', 'xmlrpcproto',
            'xmlrpctimeout',
        );
        
        $buffer = '';
        
        foreach($globalVariables as $makeMeGlobal) {
            global $$makeMeGlobal;
            // also make this variable a class attribute
            // so plugins could have an access to these values and modify them
            $this->$makeMeGlobal = &$$makeMeGlobal;
        }
        
        // Check if affiliate is on the same server as the delivery code
        if ($extra != '' && isset ($extra['website']) && $extra['website']) {
            $server_max      = parse_url('http://' . $conf['webpath']['delivery'] . '/');
            $server_affilate = parse_url($extra['website']);
            // this code could be extremely slow if host is unresolved
            $server_same     = (@gethostbyname($server_max['host']) == @gethostbyname($server_affilate['host']));
        } else {
            $server_same = true;
        }
        
        // Hide when integrated in zone-advanced.php
        if (!is_array($extra) || !isset($extra['zoneadvanced']) || !$extra['zoneadvanced']) {
            $buffer .= "<form name='generate' action='".$_SERVER['PHP_SELF']."' method='POST' onSubmit='return phpAds_formCheck(this);'>\n";
        }
        
        // Invocation type selection
        if (!is_array($extra) || (isset($extra['delivery']) && $extra['delivery'] != phpAds_ZoneInterstitial && $extra['delivery'] != phpAds_ZonePopup)) {
            
            $invocationTags = &Max_Plugins::getPlugins('invocationTags');
            
            foreach($invocationTags as $pluginKey => $invocationTag) {
                $allowed[$pluginKey] = $invocationTag->isAllowed($extra, $server_same);
            }
            
            if (!isset($codetype) || $allowed[$codetype] == false) {
                while (list($k,$v) = each($allowed))
                    if ($v) $codetype = $k;
            }
            
            if (!isset($codetype)) {
                $codetype = '';
            }
            
            
            $buffer .= "<table border='0' width='100%' cellpadding='0' cellspacing='0'>";
            $buffer .= "<tr><td height='25' colspan='3'><b>". Max_PluginTranslation::translate('Please choose the type of banner invocation', 'invocationTags') ."</b></td></tr>";
            $buffer .= "<tr><td height='35'>";
            $buffer .= "<select name='codetype' onChange=\"this.form.submit()\" accesskey=".$GLOBALS['keyList']." tabindex='".($tabindex++)."'>";
            
            foreach($invocationTags as $pluginKey => $invocationTag) {
                if($allowed[$pluginKey]) {
                    $invocationTagsNames[$pluginKey] = $invocationTag->getName();
                }
            }
            // sort by name
            asort($invocationTagsNames);
            foreach($invocationTagsNames as $pluginKey => $invocationTagName) {
                $buffer .= "<option value='".$pluginKey."'".($codetype == $pluginKey ? ' selected' : '').">".$invocationTagName."</option>";
            }
            
            $buffer .= "</select>";
            $buffer .= "&nbsp;<input type='image' src='images/".$phpAds_TextDirection."/go_blue.gif' border='0'>";
            $buffer .= "</td></tr></table>";
            
            $buffer .= phpAds_ShowBreak($print = false);
            $buffer .= "<br />";
        } else {
            $invocationTags = &Max_Plugins::getPlugins('invocationTags');
            foreach($invocationTags as $invocationCode => $invocationTag) {
                if(isset($invocationTag->defaultZone) && $extra['delivery'] == $invocationTag->defaultZone) {
                    $codetype = $invocationCode;
                    break;
                }
            }
            if (!isset($codetype)) {
                $codetype = '';
            }
        }
        if ($codetype != '') {
            // factory plugin for this $codetype
            $invocationTag = Max_Plugins::factory('invocationTags', $codetype);
            if($invocationTag === false) {
                MAX::debug('Error while factory invocationTag plugin');
                exit();
            }
            $invocationTag->setInvocation($this);
            
            // Code
            if (isset($submitbutton) || !empty($generate)) {
                $buffer .= "<table border='0' width='550' cellpadding='0' cellspacing='0'>";
                $buffer .= "<tr><td height='25'><img src='images/icon-generatecode.gif' align='absmiddle'>&nbsp;<b>".$GLOBALS['strBannercode']."</b></td>";
                
                // Show clipboard button only on IE
                if (strpos ($_SERVER['HTTP_USER_AGENT'], 'MSIE') > 0 &&
                    strpos ($_SERVER['HTTP_USER_AGENT'], 'Opera') < 1) {
                    $buffer .= "<td height='25' align='right'><img src='images/icon-clipboard.gif' align='absmiddle'>&nbsp;";
                    $buffer .= "<a href='javascript:phpAds_CopyClipboard(\"bannercode\");'>".$GLOBALS['strCopyToClipboard']."</a></td></tr>";
                } else {
                    $buffer .= "<td>&nbsp;</td>";
                }
                $buffer .= "<tr height='1'><td colspan='2' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
                $buffer .= "<tr><td colspan='2'><textarea name='bannercode' class='code-gray' rows='6' cols='55' style='width:550;' readonly>"
                    .  htmlspecialchars($this->generateInvocationCode($invocationTag))   .  "</textarea></td></tr>";
                $buffer .= "</table><br />";
                $buffer .= phpAds_ShowBreak($print = false);
                $buffer .= "<br />";
                
                $generated = true;
            } else {
                $generated = false;
            }
            
            // Hide when integrated in zone-advanced.php
            if (!(is_array($extra) && isset($extra['zoneadvanced']) && $extra['zoneadvanced'])) {
                // Header
                // Parameters Section
                $buffer .= "<table border='0' width='100%' cellpadding='0' cellspacing='0'>";
                $buffer .= "<tr><td height='25' colspan='3'><img src='images/icon-overview.gif' align='absmiddle'>&nbsp;<b>".$GLOBALS['strParameters']."</b></td></tr>";
                $buffer .= "<tr height='1'><td width='30'><img src='images/break.gif' height='1' width='30'></td>";
                $buffer .= "<td width='200'><img src='images/break.gif' height='1' width='200'></td>";
                $buffer .= "<td width='100%'><img src='images/break.gif' height='1' width='100%'></td></tr>";
            }
            
            $buffer .= $invocationTag->generateOptions($this);
            
            // Support for 3rd Party Clicktracking
            $buffer .= "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            $buffer .= "<tr><td width='30'>&nbsp;</td>";
            $buffer .= "<td width='200'>".$GLOBALS['str3rdPartyTrack']."</td>";
            $buffer .= "<td width='370'><input type='radio' name='thirdpartytrack' value='1'".(!isset($thirdpartytrack) || $thirdpartytrack != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            $buffer .= "<input type='radio' name='thirdpartytrack' value='0'".(isset($thirdpartytrack) && $thirdpartytrack == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            $buffer .= "</tr>";
            $buffer .= "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
            
            // Hide when integrated in zone-advanced.php
            if (!(is_array($extra) && isset($extra['zoneadvanced']) && $extra['zoneadvanced'])) {
                // Footer
                $buffer .= "<tr><td height='10' colspan='3'>&nbsp;</td></tr>";
                $buffer .= "<tr height='1'><td colspan='3' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
                $buffer .= "</table>";
                $buffer .= "<br /><br />";
                $buffer .= "<input type='hidden' value='".($generated ? 1 : 0)."' name='generate'>";
                if ($generated) {
                    $buffer .= "<input type='submit' value='".$GLOBALS['strRefresh']."' name='submitbutton' tabindex='".($tabindex++)."'>";
                } else {
                    $buffer .= "<input type='submit' value='".$GLOBALS['strGenerate']."' name='submitbutton' tabindex='".($tabindex++)."'>";
                }
            }
        }
        // Put extra hidden fields
        if (is_array($extra)) {
            while (list($k, $v) = each($extra)) {
                $buffer .= "<input type='hidden' value='$v' name='$k'>";
            }
        }
        // Hide when integrated in zone-advanced.php
        if (!is_array($extra) || !isset($extra['zoneadvanced']) || !$extra['zoneadvanced']) {
            $buffer .= "</form><br /><br />";
        }
        
        return $buffer;
    }
    
    function generateJavascriptTrackerCode($trackerId)
    {
        $conf = $GLOBALS['_MAX']['CONF'];
        $buffer  = "
    <!-- Max Media Manager Tracker Javascript Beacon Code
      --
      -- Put this tag in the <head> portion of the web page you want to track,
      -- below any definitions of Javascript variables you want to track. Any
      -- Javascript variables that will be tracked need to be configured in
      -- Max Media Manager, and are defined at run-time, and so are not seen
      -- mentioned in the code below.
      -->
      
    <script language='JavaScript' type='text/javascript'>
    <!--
      var az_p=location.protocol=='https:'?'https:':'http:';
      var az_r=Math.floor(Math.random()*999999);
      document.write (\"<\" + \"script language='JavaScript' \");
      document.write (\"type='text/javascript' src='\"+az_p);
      document.write (\"".constructPartialDeliveryUrl($conf['file']['conversionjs'])."\");
      document.write (\"?trackerid={$trackerId}&r=\"+az_r+\"'><\" + \"/script>\");
    //-->
    </script>";
        return $buffer;
    }

}

?>